package com.example.app;

import android.content.Context;
import android.graphics.Canvas;
import android.os.CountDownTimer;
import android.os.Handler;
import android.util.AttributeSet;
import android.util.Log;
import android.widget.ImageView;

public class Sonic extends ImageView {
	private int groundy = 400;
	private long jumping = 0;
	private boolean homing = false;
	private int 
	MOVING_LEFT = 1,
	MOVING_RIGHT = 2,
	MOVING_TIME = 0, 
	MOVING_FRAME = 1,
	MOVING_SPEED = 4,
	moving = MOVING_RIGHT,
	toX = 0,
	toY = 0;
	long animstamp = System.currentTimeMillis();
	private float y = groundy,x = groundy;
	
	private Handler handler = new Handler();
	
	public Sonic(Context context) {
		super(context);
		//super.setBackgroundResource(R.drawable.sonicstanding);
		//super.setX(10);
		//super.setY(10);
		//this.gravity = gravity;
	
	}
	
	public Sonic(Context context, AttributeSet attrs) 
	{
	    super(context, attrs);
	}
	
	public void setBackgroundColor(int color)
	{
		super.setBackgroundColor(color);
	}
	
	@Override
	protected void onDraw(Canvas canvas) 
	{
	    super.onDraw(canvas);
	}
	
	@Override
	public void setBackgroundResource(int resid)
	{
		super.setBackgroundResource(resid);
	}
	
	@Override
	public void setY(float y)
	{
		super.setY(y);
	}
	
	public void setX(float x)
	{
		super.setX(x);
	}
	
	@Override
	public float getY()
	{
		return super.getY();
	}
	
	@Override
	public float getX()
	{
		return super.getX();
	}
	
	public void setRotationY(float rotationY)
	{
		super.setRotationY(rotationY);
	}
	
	public void jumpClick()
	{
		if (jumping == 0)
		{
			jumping = System.currentTimeMillis();
			y = groundy;
			Jump(-1, 6);
		} else if (!homing && System.currentTimeMillis() - jumping > 150)
		{
			homingAttack();
		}
	}
	
	public void stopMoving()
	{
    	MOVING_SPEED = 4;
    	setBackgroundResource(R.raw.sonicstanding);
        handler.removeCallbacks(move1);
	}
	
	private void Jump(final int position, final float mov)
	{
		new CountDownTimer(400,1){

			@Override
			public void onTick(long arg0) {
				if (homing)
				{
					if (getX() < toX-3){
						x-=7;
					} else if (getX() > toX+3)
					{
						x+=7;
					}
					setX(x);
					if (position == -1)
						y+= 5;
				}
				setBackgroundResource(R.raw.sonicrolling);
				y+=position*mov;
				setY(y);
			}
			
			@Override
			public void onFinish() {
				if (position==-1){
					Log.i("Jump moved", " "+(groundy-y));
					Jump(1, 6);
				} else{					
					setBackgroundResource(R.raw.sonicstanding);
					y=groundy;
					setY(y);
					jumping = 0;
					homing = false;
				}
				
			}
			
		}.start();
	}
	
	public void moveClick(int movement)
	{
		moving = movement;
		handler.post(move1);
	}
	
	final Runnable move1 = new Runnable() {
	    @Override
	    public void run() {
	    	Log.i("MOVING_TIME", " "+MOVING_TIME);
	    	if (moving == MOVING_LEFT)
	    		move2(0-MOVING_SPEED);
	    	else if (moving == MOVING_RIGHT)
	    		move2(MOVING_SPEED);
	        // Call the runnable again
	        handler.postDelayed(this, 20);
	    }
	};
	
	public void move2 (int movement){
		x = (int)getX();
		x+=movement;
		setX(x);
		if (System.currentTimeMillis() >= animstamp+200-(MOVING_SPEED*10) && jumping == 0){
			animstamp = System.currentTimeMillis();
			switch (MOVING_FRAME){
				case 1: setBackgroundResource(R.raw.sonicmov1);
					break;
				case 2: setBackgroundResource(R.raw.sonicmov2);
					break;
				case 3: setBackgroundResource(R.raw.sonicmov3);
					break;
				case 4: setBackgroundResource(R.raw.sonicmov4);
					break;
				case 5: setBackgroundResource(R.raw.sonicmov5);
					break;
				case 6: setBackgroundResource(R.raw.sonicmov6);
					break;
				case 7: setBackgroundResource(R.raw.sonicmov7);
					break;
				case 8: setBackgroundResource(R.raw.sonicmov8);
					break;
			}
			if (moving == MOVING_LEFT){
				//view.setRotation(180);
				setRotationY(180);
				
			} else {
				setRotationY(0);
			}
			MOVING_FRAME++;
			if (MOVING_FRAME > 8){
				MOVING_FRAME = 1;
			}
			if (MOVING_FRAME%2==0){
				if (MOVING_SPEED < 15)
					MOVING_SPEED++;
			}
		}
	}
	
	private void homingAttack()
	{
		if (moving == MOVING_LEFT)
			toX = (int)getX() + 90;
		else 
			toX = (int)getX() - 90;
		toY = (int)getY();
		homing = true;
	}
	
}