package me.sonic.dash;

/**
 * Created by Leonie on 7/2/13.
 */
import android.util.Log;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.MotionEvent;

public class GestureListener extends GestureDetector.SimpleOnGestureListener {
    public int lastSwipeDir = 0;
    private static final int SWIPE_MIN_DISTANCE = 120;
    private static final int SWIPE_MAX_OFF_PATH = 250;
    private static final int SWIPE_THRESHOLD_VELOCITY = 200;

    public GestureListener(){
        Log.i("Gestures","Gesturelistener created");
    }

    @Override
    public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX,
                           float velocityY) {
        Log.i("Gestures", "OnFling");
        try {
            if (Math.abs(e1.getX() - e2.getX()) > SWIPE_MAX_OFF_PATH){
                Log.i("Gestures", "False");
                return false;
            }
            // right to left swipe
            if (e1.getY() - e2.getY() > SWIPE_MIN_DISTANCE
                    && Math.abs(velocityY) > SWIPE_THRESHOLD_VELOCITY) {
                lastSwipeDir = -1;
                Log.i("Gestures", "-1");
                return true;
            }
            // left to right swipe
            else if (e2.getY() - e1.getY() > SWIPE_MIN_DISTANCE
                    && Math.abs(velocityY) > SWIPE_THRESHOLD_VELOCITY) {
                lastSwipeDir = 1;
                Log.i("Gestures", "1");
            }
        } catch (Exception e) {
        }
        return false;
    }
    @Override
    public boolean onDown(MotionEvent e) {
        return true;
    }

}
